"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const execa = require("execa");
const path = require("path");
const _1 = require("./");
// Action can be "install" or "uninstall"
// huskyDir is ONLY used in dev, don't use this arguments
const [, , action, huskyDir = path.join(__dirname, '../..')] = process.argv;
// Find Git dir
const { status, stdout, stderr } = execa.sync('git', ['rev-parse', '--git-dir']);
const gitDir = path.resolve(stdout); // Needed to normalize path on Windows
if (status !== 0) {
    console.log(stderr);
    process.exit(1);
}
// Run installer
if (action === 'install') {
    _1.install(gitDir, huskyDir);
}
else {
    _1.uninstall(gitDir, huskyDir);
}
